import java.util.Calendar;

import quadbase.reportdesigner.util.IExportConstants;
import quadbase.reportorganizer.organizerAPI.QbOrganizer;
import quadbase.reportorganizer.organizerAPI.QbScheduleObject;
import quadbase.reportorganizer.organizerAPI.QbSchedulePackage;

public class SchedulingExportReportTimeERES {
	// set following constants, your ERES server must be runnning!
	static final String ServletRunner = "http://localhost:8080";
	static final String ServletContext = "ERES/servlet";

	public static void main(String[] args) {
		SchedulingExportReportTimeERES doScheduleExport = new SchedulingExportReportTimeERES();
		try {
			doScheduleExport.createScheduleObject();
		} catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	void createScheduleObject() throws Exception {
		QbOrganizer.setServletContext(ServletContext);
		QbOrganizer.setServletRunner(ServletRunner);
		QbOrganizer organizer = new QbOrganizer(null, "admin", "admin");

		QbSchedulePackage sPack = new QbSchedulePackage("Report_Time", organizer);
		sPack.setReportExportType(IExportConstants.PDF);
		sPack.setTaskOption(QbSchedulePackage.FIXED_DAYS);

		/*** export every 2 hrs. Monday through Friday ****/
		sPack.setSpecifyDays(new int[] { 1, 2, 3, 4, 5 });
		sPack.setStartTime(9 * 60); // 9:00AM in minutes
		sPack.setEndTime(22 * 60); // 10:00PM in minutes
		sPack.setTimeInterval(2 * 60); // export every 2 hours

		/*** export at specific times on specific dates ***/
		//sPack.setSpecifyDates(new int[]{26,27,28,29}); // export on specific dates
		//sPack.setSpecifyTime(new int[]{16 * 60, 17 * 60, 18 * 60}); // 4PM, 5PM and 6PM in minute

		Calendar calendar = Calendar.getInstance();
		calendar.add(Calendar.MINUTE, 5);
		sPack.setStartDate(calendar.getTimeInMillis());
		sPack.setEndDate(-1); // run indefinitely
		sPack.setSendEmail(false);

		QbScheduleObject sObj = new QbScheduleObject("report1",
				QbScheduleObject.TEMPLATE_TYPE_REPORT, sPack);
		sObj.setFileLocation("Account.rpt");
		String exportLocation = sObj.pickDefaultExportLocation();

		organizer.getScheduler().addSchedulePackageTask(sPack);
	}
}
